package com.ademicon.service.auth;

import java.net.ConnectException;

import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import com.ademicon.model.auth.AccessModel;
import com.ademicon.model.auth.AuthenticationModel;
import com.fasterxml.jackson.databind.ObjectMapper;

public class AuthenticationService {

    private static AccessService accessService = new AccessService();

    public AuthenticationModel getToken() throws Exception {
        try {

            AccessModel accessModel = accessService.find();

            WebTarget webTarget = ClientBuilder.newBuilder().build()
                    .target(accessModel.getPlaceti_url_base() + accessModel.getPlaceti_url_token());

            Response response = webTarget
                    .queryParam("grant_type", "client_credentials")
                    .request(MediaType.APPLICATION_JSON)
                    .header("authorization", "Basic " + accessModel.getPlaceti_user_token())
                    .build("POST").invoke();
            int status = response.getStatus();
            if (status == 200) {
                String json = response.readEntity(String.class);
                ObjectMapper mapper = new ObjectMapper();
                return mapper.readValue(json, AuthenticationModel.class);
                
            } else {
                throw new ConnectException();

            }

        } catch (Exception e) {
            System.out.println(e);
            throw new Exception(e.getMessage());

        }
    }
}
